/**
 * 
 */
package de.mpiwg.itgroup.annotations;

/**
 * @author casties
 *
 */
public class Annotation {
    /**
     * The URI of this annotation.
     */
    protected String uri;

    /**
     * The annotation (body) text.
     */
    protected String bodyText;

    /**
     * The URI of the annotation text
     */
    protected String bodyUri;
    
    /**
     * The base URI of the annotation target.
     */
    protected String targetBaseUri;
    
    /**
     * The fragment part of the annotation target.
     */
    protected String targetFragment;
    
    /**
     * The types of annotation targets.
     *
     */
    public static enum FragmentTypes {
        XPOINTER, AREA
    };
    
    /**
     * The type of the annotation target fragment.
     */
    protected FragmentTypes fragmentType;
    
    /**
     * The creator of this annotation.
     */
    protected Actor creator;
    
    /**
     * The creation date of this annotation.
     */
    protected String created;

    protected String adminPermission;
    
    /**
     * @return the uri
     */
    public String getUri() {
        return uri;
    }

    /**
     * @param uri the uri to set
     */
    public void setUri(String uri) {
        this.uri = uri;
    }

    /**
     * @return the bodyText
     */
    public String getBodyText() {
        return bodyText;
    }

    /**
     * @param bodyText the bodyText to set
     */
    public void setBodyText(String bodyText) {
        this.bodyText = bodyText;
    }

    /**
     * @return the bodyUri
     */
    public String getBodyUri() {
        return bodyUri;
    }

    /**
     * @param bodyUri the bodyUri to set
     */
    public void setBodyUri(String bodyUri) {
        this.bodyUri = bodyUri;
    }

    /**
     * @return the targetBaseUri
     */
    public String getTargetBaseUri() {
        return targetBaseUri;
    }

    /**
     * @param targetBaseUri the targetBaseUri to set
     */
    public void setTargetBaseUri(String targetBaseUri) {
        this.targetBaseUri = targetBaseUri;
    }

    /**
     * @return the targetFragment
     */
    public String getTargetFragment() {
        return targetFragment;
    }

    /**
     * @param targetFragment the targetFragment to set
     */
    public void setTargetFragment(String targetFragment) {
        this.targetFragment = targetFragment;
    }

    /**
     * @return the targetType
     */
    public FragmentTypes getFragmentType() {
        return fragmentType;
    }

    /**
     * @param fragmentType the fragmentType to set
     */
    public void setFragmentType(FragmentTypes fragmentType) {
        this.fragmentType = fragmentType;
    }

    /**
     * @return the creator
     */
    public Actor getCreator() {
        return creator;
    }

    /**
     * @param creator the creator to set
     */
    public void setCreator(Actor creator) {
        this.creator = creator;
    }

    /**
     * @return the creatorUri
     */
    public String getCreatorUri() {
        if (creator != null) {
            return creator.getUri();
        }
        return null;
    }

    /**
     * @return the creatorName
     */
    public String getCreatorName() {
        if (creator != null) {
            return creator.getName();
        }
        return null;
    }

    /**
     * @return the created
     */
    public String getCreated() {
        return created;
    }

    /**
     * @param created the created to set
     */
    public void setCreated(String created) {
        this.created = created;
    }
    
    
}
